#pragma rtGlobals= 2
#pragma version = 2.6
DefaultFont "Helvetica"
#pragma IndependentModule=JZTgeneral

Menu "Analysis"
	Submenu "Packages"
		"-"
		"Physical Constants",Execute/P "INSERTINCLUDE  \"PhysicalConstants\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load Package of Physical Constants."}
		"FWHM",Execute/P "INSERTINCLUDE  \"FWHM\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load commands for getting FWHM."}
		"spec files",Execute/P "INSERTINCLUDE  \"spec\"";Execute/P "INSERTINCLUDE  \"specMore\"";Execute/P "COMPILEPROCEDURES ";Execute/P "specInitPackage()"
		help = {"Load everything for reading spec files."}
		"MDA files",Execute/P "INSERTINCLUDE  \"mdaFiles\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load mda files (from APS)."}
		"BURT Files",Execute/P "INSERTINCLUDE  \"BurtFiles\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load Burt files (from APS)."}
		"Gizmo Markers & Zoom", Execute/P "INSERTINCLUDE \"GizmoZoomTranslate\", version>=1.06" ; 	Execute/P "COMPILEPROCEDURES ";Execute/P "InitGizmoZoomTranslate()"
		help = {"Provide support of Zooming Gizmos and putting a 'Cursor' on a Gizmo"}
		// "Color Names", Execute/P "INSERTINCLUDE \"ColorNames\"" ; 	Execute/P "COMPILEPROCEDURES ";Execute/P " InitColorNames()"
		"Color Names", Execute/P "INSERTINCLUDE \"ColorNames\"" ; 	Execute/P "COMPILEPROCEDURES "
		help = {"Load procedures that will provide names for RGBA colors"}
		"Image Display Range", Execute/P "INSERTINCLUDE \"ImageDisplayScaling\"" ; 	Execute/P "COMPILEPROCEDURES "
		help = {"Load procedures that set range of color table based on a Marquee region"}

		// "WinView Reader", Execute/P "INSERTINCLUDE \"WinView\", version>=1.82" ; 	Execute/P "INSERTINCLUDE \"ImageDisplayScaling\", version>=1.41" ; 	Execute/P "COMPILEPROCEDURES "
		"WinView Reader", Execute/P "INSERTINCLUDE \"WinView\", version>=1.97"
		help = {"Load procedures reading and looking at WinView images"}
		SubMenu "X-ray"
			"X-ray Data",Execute/P "INSERTINCLUDE  \"Xray\", version>=2.21";Execute/P "COMPILEPROCEDURES ";Execute/P "ElementDataInitPackage()"
			help = {"Load procedures for providing X-ray data"}
			"  Elements Data",Execute/P "INSERTINCLUDE  \"Elements\", version>=1.65";Execute/P "COMPILEPROCEDURES ";Execute/P "ElementDataInitPackage()"
			help = {"Load procedures for providing data on the elements"}
			"  Cromer-Liberman",Execute/P "INSERTINCLUDE  \"CromerLiberman\", version>=1.6";Execute/P "COMPILEPROCEDURES "
			help = {"Load procedures for providing Cromer-Liberman"}
			"Multi-Layer Reflectivity",Execute/P "INSERTINCLUDE  \"MultiLayerReflectivity\", version>=1.0";Execute/P "COMPILEPROCEDURES "
			help = {"Load procedures calculating x-ray reflectivity from multilayers"}
			"Multiple Reflections",Execute/P "INSERTINCLUDE  \"Umwegs\", version>=1.0";Execute/P "COMPILEPROCEDURES "
			help = {"Load procedures for analyzing Umwegs"}
			"Ion Chamber",Execute/P "INSERTINCLUDE  \"IonChamber\", version>=2.2";Execute/P "COMPILEPROCEDURES ";Execute/P "ionChamberInitPackage()"
			help = {"Load procedures for evaluating ion chamber output"}
			"Lattices",Execute/P "INSERTINCLUDE  \"LatticeSym\", version>=3.65";Execute/P "COMPILEPROCEDURES ";Execute/P "InitLatticeSymPackage()"
			help = {"Load lattice symmetry procedures"}
		End
		"Neutron Scattering Data",Execute/P "INSERTINCLUDE  \"Neutron\", version>=1.0";Execute/P "COMPILEPROCEDURES ";Execute/P "NeutronDataInitPackage()"
		help = {"Load procedures for providing Neutron Scattering Data"}
		//	"Add Local User Packages...", /Q,AddLocalUserPackages()
		SubMenu "Add Local User Packages..."
			JZTgeneral_CheckForUserPackages(), /Q,JZTgeneral_StartUpLocalPackage()
		End
		"-"
	End
End
//
Menu "Data"
	SubMenu "Packages"
		"MDA files from APS",Execute/P "INSERTINCLUDE  \"mdaFiles\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load mda files (from APS)."}
		"BURT files from APS",Execute/P "INSERTINCLUDE  \"BurtFiles\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load Burt files (from APS)."}
	End
End
Menu "Load Waves"
	SubMenu "Packages"
		"MDA files from APS",Execute/P "INSERTINCLUDE  \"mdaFiles\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load mda files (from APS)."}
		"BURT files from APS",Execute/P "INSERTINCLUDE  \"BurtFiles\"";Execute/P "COMPILEPROCEDURES "
		help = {"Load Burt files (from APS)."}
	End
End
//
// This provides for an easy way to load any package in the folder "Documents:WaveMetrics:Igor Pro 6 User Files:User Procedures/Local Packages"
//  just put the ipf file in there and it will be available to this function for loading.
//  if the first 50 lines of the file contain a line such as   "#requiredPackages "HDF5images;microGeometryN;", then it will only load that file if the 
//  ipf files in the list are already loaded.
Function JZTgeneral_StartUpLocalPackage()
	GetLastUserMenuInfo			// sets S_value, V_value, etc.
	String pkg=S_value

	if (V_flag || !stringmatch(pkg,"*.ipf" ))
		return 1
	endif
	String initFuncs=getInitFunctionsName(pkg), cmd
	pkg = ReplaceString(".ipf",pkg,"")
	print "\r  adding local package  ",pkg
	sprintf cmd, "Execute/P \"INSERTINCLUDE  \\\"%s\\\"\";Execute/P \"COMPILEPROCEDURES \"", pkg
	if (strlen(initFuncs))
		cmd += ";Execute/P \""+initFuncs+" \""
	endif
//print "cmd = ",cmd
	Execute cmd
	return 0
End
//Function AddLocalUserPackages()
//	String list=CheckForUserPackages(), cmd, pkg
//	if (ItemsInLIst(list)<1)
//		DoAlert 0, "No Local Packages Available for Loading"
//		return 0
//	endif
//	Prompt pkg,"Package",popup,list
//	DoPrompt "Package",pkg
//	if (V_flag || cmpstr(pkg,"_none_")==0)
//		return 1
//	endif
//	String initFuncs = getInitFunctionsName(pkg)
//	pkg = ReplaceString(".ipf",pkg,"")
//	print "\r  adding local package  ",pkg
//	sprintf cmd, "Execute/P \"INSERTINCLUDE  \\\"%s\\\"\";Execute/P \"COMPILEPROCEDURES \"", pkg
//	if (strlen(initFuncs))
//		cmd += ";Execute/P \""+initFuncs+" \""
//	endif
//	Execute cmd
//	return 0
//End
//
Static Function/T getInitFunctionsName(ipf)
	String ipf						// name of name of ipf file
	NewPath/O/Q/Z lpath__Temp ,  SpecialDirPath("Documents", 0, 0, 0 )+"WaveMetrics:Igor Pro 6 User Files:User Procedures:Local Packages:"

	String line, initFunc=""
	Variable f, i,i0,i1
	Open/R/P=lpath__Temp/T=".ipf"/Z f as ipf
	for (i=0;i<50;i+=1)
		FReadLine/N=500 f, line
		if (strlen(line)==0)				// end of file
			Close f
			return initFunc
		endif
		if (strsearch(line,"#initFunctionName",0)==0)
			i0 = strsearch(line,"\"",0)
			i1 = strsearch(line,"\"",i0+1)
			if (i0==-1 || i1==-1 || i1<=i0)
				break
			endif
			initFunc = line[i0+1,i1-1]
			break
		endif
	endfor
	Close f
	return initFunc
End
//
Function/T JZTgeneral_CheckForUserPackages()
	NewPath/O/Q/Z lpath__Temp ,  SpecialDirPath("Documents", 0, 0, 0 )+"WaveMetrics:Igor Pro 6 User Files:User Procedures:Local Packages:"
	if (V_flag)
		return ""
	endif
	String fname,list="",required
	Variable i=0
	do
		fname = IndexedFile(lpath__Temp,i,".ipf")
		if (strlen(fname)==0)
			break
		endif
		if (allProcsArePresent(ReplaceString(".ipf",fname,"")))
			i += 1
			continue
		endif
		required = getListOfRequiredProcs("lpath__Temp",fname)
		if (allProcsArePresent(required))
			list = AddListItem(fname,list)
		endif
		i += 1
	while (1)
	KillPath/Z lpath__Temp
	return list
End
//
Static Function/T getListOfRequiredProcs(path,ipf)
	String path, ipf
	String line, list=""
	Variable f, i,i0,i1
	Open/R/P=$path/T=".ipf"/Z f as ipf
	for (i=0;i<50;i+=1)
		FReadLine/N=500 f, line
		if (strlen(line)==0)				// end of file
			Close f
			return list
		endif
		if (strsearch(line,"#requiredPackages",0)==0)
			i0 = strsearch(line,"\"",0)
			i1 = strsearch(line,"\"",i0+1)
			if (i0==-1 || i1==-1 || i1<=i0)
				break
			endif
			list = line[i0+1,i1-1]
			break
		endif
	endfor
	Close f
	return list
End
//
Static Function allProcsArePresent(list)
	String list
	String ipf
	Variable i,N=ItemsInList(list)
	for (i=0;i<N;i+=1)
		ipf = StringFromList(i,list)+".ipf"
		if (ItemsInList(WinList(ipf,";","WIN:128"))<1)
			return 0
		endif
	endfor
	return 1
End
